/*
 * 쐬: 2004/12/18
 *
 * TODO ̐ꂽt@C̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */
package com.muimi.kaburobo;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.debug.core.DebugPlugin;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.ILaunchConfigurationType;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.debug.core.ILaunchManager;
import org.eclipse.debug.ui.DebugUITools;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.launching.IJavaLaunchConfigurationConstants;
import org.eclipse.jdt.launching.IRuntimeClasspathEntry;
import org.eclipse.jdt.launching.IVMInstall;
import org.eclipse.jdt.launching.JavaRuntime;



/**
 * @author miya
 *
 * TODO ̐ꂽ^Rg̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */
public class KaburoboLauncher 
implements IJavaLaunchConfigurationConstants
{

    private String robotClassName;
    private IJavaProject javaProject;
    private String runMode = ILaunchManager.RUN_MODE;
    
    private String classToLaunch = "jp.kaburobo.driver.KabuRoboDriver";
    private String vmArgs = "-Dkaburobo.home=C:/data/projects/kaburobo/kaburobo_ver_1_2_5/kaburobo";
    
    
    public void setRobotClassName(String robotClassName){
        this.robotClassName = robotClassName;
    }
    
    public void setJavaProject(IJavaProject javaProject){
        this.javaProject = javaProject;
    }
    
    public void setRunMode(String runMode){
        this.runMode = runMode;
    }
    
    
    public void runRoboto() throws CoreException{
        
		IVMInstall jre =  JavaRuntime.getDefaultVMInstall();

		ILaunchManager manager = DebugPlugin.getDefault().getLaunchManager();
		ILaunchConfigurationType type = manager.getLaunchConfigurationType(ID_JAVA_APPLICATION);
		
		ILaunchConfiguration[] configurations = manager.getLaunchConfigurations(type);
		for (int i = 0; i < configurations.length; i++) {
			ILaunchConfiguration configuration = configurations[i];
			if (configuration.getName().equals("Kaburobo")) {
				configuration.delete();
				break;
			}
		}
		ILaunchConfigurationWorkingCopy workingCopy = type.newInstance(null, "Kaburobo");
		
		workingCopy.setAttribute(ATTR_VM_INSTALL_NAME, jre.getName());
		workingCopy.setAttribute(ATTR_VM_INSTALL_TYPE, jre.getVMInstallType().getId());
			
		workingCopy.setAttribute(ATTR_MAIN_TYPE_NAME, classToLaunch);
		workingCopy.setAttribute(ATTR_PROGRAM_ARGUMENTS, robotClassName);
			
		// specify classpath
		File jdkHome = jre.getInstallLocation();
		IPath toolsPath = new Path(jdkHome.getAbsolutePath()).append("lib").append("tools.jar");
		IRuntimeClasspathEntry toolsEntry = JavaRuntime.newArchiveRuntimeClasspathEntry(toolsPath);
		toolsEntry.setClasspathProperty(IRuntimeClasspathEntry.USER_CLASSES);
			
		IPath systemLibsPath = new Path(JavaRuntime.JRE_CONTAINER);
		IRuntimeClasspathEntry systemLibsEntry = JavaRuntime.newRuntimeContainerClasspathEntry(systemLibsPath, IRuntimeClasspathEntry.STANDARD_CLASSES);
		
		IRuntimeClasspathEntry projectEntry = JavaRuntime.newProjectRuntimeClasspathEntry(javaProject);
				
		List classpath = new ArrayList();
		classpath.add(toolsEntry.getMemento());
	
		classpath.add(projectEntry.getMemento());
		
		IRuntimeClasspathEntry[] kaburoboClassPath = getKaburoboClassPath();
		for(int i=0; i<kaburoboClassPath.length; i++){
		    classpath.add(kaburoboClassPath[i].getMemento());
		}
		
		classpath.add(systemLibsEntry.getMemento());
			
		workingCopy.setAttribute(ATTR_CLASSPATH, classpath);
		workingCopy.setAttribute(ATTR_DEFAULT_CLASSPATH, false);
			
		workingCopy.setAttribute(ATTR_VM_ARGUMENTS, vmArgs);
			
		//File workingDir = JavaCore.getClasspathVariable("TOMCAT_HOME").append("bin").toFile();
		//File workingDir = new Path(tomcatHome).append("bin").toFile();
		//workingCopy.setAttribute(ATTR_WORKING_DIRECTORY, workingDir.getAbsolutePath());
			
		// save and launch
		ILaunchConfiguration configuration = workingCopy.doSave();
		DebugUITools.launch(configuration, runMode);

    }
    
    private IRuntimeClasspathEntry[] getKaburoboClassPath(){      
        String[] jars = new String[]{
	        "kaburobo.jar",
	        "hsqldb.jar",
	        "xalan.jar",
        };
        IRuntimeClasspathEntry[] entries = new IRuntimeClasspathEntry[jars.length];
        for(int i=0; i<entries.length; i++){
            System.out.println(jars[i]);
            IPath path = new Path(KaburoboPlugin.KABUROBO_HOME_CLASSPATH_VARIABLE).append("lib").append(jars[i]);
            entries[i] = JavaRuntime.newVariableRuntimeClasspathEntry(path);
            entries[i].setClasspathProperty(IRuntimeClasspathEntry.USER_CLASSES);            
        }

        return entries;
    }
    

    
}
