/*
 * 쐬: 2004/12/18
 *
 * TODO ̐ꂽt@C̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */
package com.muimi.kaburobo;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import org.eclipse.ant.core.AntRunner;
import org.eclipse.core.internal.variables.StringVariableManager;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.variables.IStringVariableManager;
import org.eclipse.core.variables.IValueVariable;
import org.eclipse.jdt.core.IClasspathEntry;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.ui.JavaUI;

/**
 * @author miya
 * 
 * TODO ̐ꂽ^Rg̃ev[gύXɂ͎փWv: EBhE - ݒ - Java - R[hEX^C -
 * R[hEev[g
 */
public class KaburoboProjectConfigurator {

    private IProject project;
    private IJavaProject javaProject;
    private IProgressMonitor monitor;
    
    
    public KaburoboProjectConfigurator(IProject project, IProgressMonitor monitor) {
        this.project = project;
        this.monitor = monitor;
        this.javaProject = JavaCore.create(project);
        if(javaProject == null){
            throw new IllegalStateException("fail to create JavaProject");
        }
    }
    

    public void congigure() throws CoreException {

//        createDefaultJavaLayout();
                
//        createKaburoboClassPath();

//        createLaunchConfiguration();

//        createKaburoboHomeVariable();

        copyResources();

        addJavaDoc();        
        
        project.refreshLocal(IResource.DEPTH_INFINITE, monitor);
    }

    
    
//    private void createDefaultJavaLayout() throws JavaModelException{
//               
//        IFolder srcFolder = javaProject.getProject().getFolder("src");
//        //IFolder binFolder = javaProject.getProject().getFolder("bin");
//        
//		IClasspathEntry[] entries= javaProject.getRawClasspath();
//		IClasspathEntry[] newEntries= new IClasspathEntry[entries.length + 1];
//		System.arraycopy(entries,0, newEntries,0, entries.length);
//
//        //javaProject.setOutputLocation(binFolder.getFullPath(), monitor);
//		newEntries[entries.length] = JavaCore.newSourceEntry(srcFolder.getFullPath());
//		javaProject.setRawClasspath(newEntries, monitor);
//
//    }
    
    
    
    private void createKaburoboClassPath() throws JavaModelException {
        IPath kaburoboHomePath = new Path(
                KaburoboPlugin.KABUROBO_HOME_CLASSPATH_VARIABLE);

        IClasspathEntry[] entries = javaProject.getRawClasspath();
        List cp = new ArrayList(entries.length + 1);

        for (int i = 0; i < entries.length; i++) {
            IClasspathEntry entry = entries[i];
            if (!((entry.getEntryKind() == IClasspathEntry.CPE_VARIABLE) && (entry
                    .getPath().toOSString().startsWith(kaburoboHomePath
                    .toOSString())))) {
                cp.add(entry);
            }
        }

        IPath kaburoboJarPath = kaburoboHomePath.append("lib").append(
                "kaburobo.jar");
        IPath kaburoboSourceAttachPath = kaburoboHomePath.append("src");
        cp.add(JavaCore.newVariableEntry(kaburoboJarPath,
                kaburoboSourceAttachPath, null));

        cp.add(JavaCore.newVariableEntry(kaburoboHomePath.append("lib").append(
                "hsqldb.jar"), null, null));
        cp.add(JavaCore.newVariableEntry(kaburoboHomePath.append("lib").append(
                "xalan.jar"), null, null));

        


        javaProject.setRawClasspath((IClasspathEntry[]) cp
                .toArray(new IClasspathEntry[cp.size()]), null);

    }
    
    
    
    private void addJavaDoc(){
        try {
            //CuϐƓYtłȂ݂Ȃ̂ŕʓrYt
            String kaburoboHomeValue = KaburoboPlugin.getDefault().getKaburoboHomePath();
            IPath absKaburoboJarPath = new Path(kaburoboHomeValue).append("lib").append("kaburobo.jar");
            
            File javaDocFile = new File(kaburoboHomeValue + "/doc/javadoc/");
            URL javaDocURL = javaDocFile.toURL();
            
            JavaUI.setLibraryJavadocLocation(absKaburoboJarPath, javaDocURL);

        } catch (MalformedURLException e) {
            e.printStackTrace();
        }
    }
    
    

    private void createLaunchConfiguration() throws CoreException {

        KaburoboLaunchConfigBuilder builder = new KaburoboLaunchConfigBuilder();
        builder.setJavaProject(javaProject);
        builder.createLaunchConfig();

    }

    private void createKaburoboHomeVariable() throws CoreException {

        IStringVariableManager manager = StringVariableManager.getDefault();

        IValueVariable variable = manager
                .getValueVariable(KaburoboPlugin.STRING_VAR_KEY_KABUROBO_HOME);
        if (variable == null) {
            variable = manager.newValueVariable(
                    KaburoboPlugin.STRING_VAR_KEY_KABUROBO_HOME,
                    "Ju{̃z[fBNg");
            variable
                    .setValue(KaburoboPlugin.getDefault().getKaburoboHomePath());
            manager.addVariables(new IValueVariable[] { variable });
        }
    }

    private void copyResources() throws CoreException {

        String buildFileLoc = KaburoboPlugin.getFilePath("resource/build.xml");
        String fromDir = KaburoboPlugin.getFilePath("templates/basic");
        String toDir = javaProject.getProject().getLocation().toOSString();
        String kaburoboHome = KaburoboPlugin.getDefault().getKaburoboHomePath();
        kaburoboHome = kaburoboHome.replaceAll("\\\\","/");
        
        Properties userProperties = new Properties();
        userProperties.setProperty("kaburobo.from.dir", fromDir);
        userProperties.setProperty("kaburobo.to.dir", toDir);
        userProperties.setProperty("kaburobo.home", kaburoboHome);

        
        AntRunner runner = new AntRunner();
        runner.setBuildFileLocation(buildFileLoc);
        runner.addUserProperties(userProperties);
        runner.run(monitor);

    }

}